/*
  tiles.cpp
  OpenTTD 32bpp Tile Tool
  Made by Luca Spiller 2005
  For more info on OpenTTD see http://www.openttd.org/
  
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the
 Free Software Foundation, Inc., 
 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <string>
#include "tiles.h"

SDL_Surface *LoadImage(char *file, int r, int g, int b)
{
	SDL_Surface *temp;
	
	temp = SDL_LoadBMP(file);
	if(temp == NULL) {
		printf("ERROR!\nFailed to open image `%s`\n", file);
		return NULL;
	}
	
	// set the transparent colour
	SDL_SetColorKey(temp, SDL_SRCCOLORKEY, SDL_MapRGB(temp->format, r, g, b));
	
	return SDL_DisplayFormat(temp);
}

int LoadTileSet(char *dir)
{
	char filename[255];
	char name[255];
	char buffer[255];
	FILE *fp;
	int r, g, b, x, y;
	int zoom;
	
	sprintf(filename, "data/%s/info", dir);
	
	fp = fopen(filename, "r");
	
	if(fp == NULL)
	{
		printf("ERROR!\nFailed to open header `%s`\n", filename);
		return 0;
	}
	
	while(!feof(fp))
	{
		fgets(buffer, 255, fp);
		if(buffer[0] != '#' && buffer[0] != '\r' && buffer[0] != '\0' && buffer[0] != '\n' && strlen(buffer) != 0)
		{
			sscanf(buffer, "%s R%d G%d B%d Z%d X%d Y%d", name, &r, &g, &b, &zoom, &x, &y);
			sprintf(filename, "data/%s/%s", dir, name);
			
			_tiles_images[_loaded_tile_images][zoom].image = LoadImage(filename, r, g, b);
			_tiles_images[_loaded_tile_images][zoom].offset_x = x;
			_tiles_images[_loaded_tile_images][zoom].offset_y = y;
			_tiles_images[_loaded_tile_images][zoom].name = dir;
		}
	}
	
	return 1;
}
